<template>
  <div class="flex flex-center q-mt-xl q-ml-xl q-mr-xl">
    <q-responsive :ratio="16 / 9"> </q-responsive>
    <q-table
      class="my-sticky-header-table"
      title="Users"
      :rows="rows"
      :columns="columns"
      row-key="id"
      style="overflow: auto"
      flat
      bordered
    >
      <template v-slot:body-cell-action="props">
        <q-td :props="props">
          <q-btn
            dense
            round
            flat
            color="blue"
            @click="(evt) => getRow(evt, props.row)"
            icon="edit"
          ></q-btn>
          <q-btn
            dense
            round
            flat
            color="red-10"
            @click="(evt) => deleteRow(evt, props.row)"
            icon="delete"
          ></q-btn>
        </q-td>
      </template>
    </q-table>
  </div>
</template>
<style lang="sass">
.my-sticky-header-table
  /* height or max-height is important */
  height: 530px
  .q-table__top,
  .q-table__bottom,
  thead tr:first-child th
    /* bg color is important for th; just specify one */
    background-color: #1976d2
    color:#fff


  thead tr th
    position: sticky
    z-index: 1
    color:#fff
    font-size:14px
  thead tr:first-child th
    top: 0
  /* this is when the loading indicator appears */
  &.q-table--loading thead tr:last-child th
    /* height of all previous header rows */
    top: 48px
  .q-table__title
    font-size:2rem
</style>
<script>
import {
  rows,
  columns,
  form,
  selectedRow,
} from "../composables/UserManagement";
import { useRouter } from "vue-router";
import axios from "axios";

import { ref } from "vue";

export default {
  name: "ListUserPage",
  setup() {
    const router = useRouter();
    //get row
    const getRow = (evt, row) => {
      const {
        name,
        username,
        email,
        street,
        suite,
        city,
        zipcode,
        lat,
        lng,
        phone,
        website,
        company,
        catchPhrase,
        bs,
      } = row;
      selectedRow.value = row;
      Object.assign(form.value, {
        name,
        username,
        email,
        street,
        suite,
        city,
        zipcode,
        lat,
        lng,
        phone,
        website,
        company,
        catchPhrase,
        bs,
      });
      router.push({ name: "add-user" });
      console.log(selectedRow.value.id);
    };

    //delete row
    const deleteRow = (evt, row) => {
      console.log(row.id);
      axios.delete(`http://localhost:3000/users/${row.id}`).then((response) => {
        if (response.status === 200) {
          rows.value = rows.value.filter((index) => index.id !== row.id);
        }
      });
    };
    return { columns, rows, getRow, form, selectedRow, deleteRow };
  },
};
</script>
